classdef SensorGloveV2 < handle;
    
    properties
        jglove;
        callbacks = {};
        port;
    end
  
    
    methods
        
        function obj = SensorGloveV2(port)
            obj.port = port;
        end
        
        function start(obj)
            if(ishandle(obj.jglove))
                set(obj.jglove, 'PropertyChangeCallback',{});
                obj.jglove.close();
                obj.jglove.delete();
            end
            obj.jglove = handle(sensorGlove.GloveBT(obj.port),'CallbackProperties');
            set(obj.jglove, 'PropertyChangeCallback',@obj.callback);
            obj.jglove.open();
        end
        
        function setMotorValues(obj, values)
            intValues = int32(values);
            obj.jglove.setMotorValues(intValues);
        end
        
        function stop(obj)
            if(ishandle(obj.jglove))
                set(obj.jglove, 'PropertyChangeCallback',{});
                obj.jglove.close();
                obj.jglove.delete();
            end
        end

        function addCallback(obj, cb)
            obj.callbacks{end+1} = cb;
        end
        
        function callback(obj, handle, event)
            
            dataObj = event.getNewValue();
            
            %flexData = double(typecast(event.getNewValue(),'int32'));
            cellfun(@(cb)cb(dataObj),obj.callbacks);
        end
        
        function delete(obj)
            obj.callbacks = {};
            obj.stop();
        end
        
    end
    
end

